source/accounts/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from .views import register_view, UserDetailView, UserPersonalInfoChangeView, UserPasswordChangeView

app_name = 'accounts'

urlpatterns = [
    path('login/', LoginView.as_view(), name='login'),
    path('logout/', LogoutView.as_view(), name='logout'),
    path('create/', register_view, name='create'),
    path('<int:pk>/', UserDetailView.as_view(), name='detail'),
    path('<int:pk>/update', UserPersonalInfoChangeView.as_view(), name='update'),
    path('<int:pk>/password_change', UserPasswordChangeView.as_view(), name='password_change')
]

source/api/urls.py
from django.urls import path
from .views import product_list_view, product_list_view_v2, \
    product_create_view, product_create_view_v2

app_name = 'api_v1'


urlpatterns = [
    path('products/', product_list_view, name='product_list'),
    path('products/v2/', product_list_view_v2, name='product_list_v2'),
    path('products/create/', product_create_view, name='product_create'),
    path('products/create/v2/', product_create_view_v2, name='product_create_v2')
]

source/main/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),
    path('', include('webapp.urls')),
    path('api/v1/', include('api.urls')),
    path('api/v2/', include('api_v2.urls')),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework'))
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

source/accounts/models.py
from django.db import models
from django.contrib.auth.models import User


class Profile(models.Model):
    user = models.OneToOneField(User, related_name='profile', on_delete=models.CASCADE, verbose_name='Пользователь')
    birth_date = models.DateField(null=True, blank=True, verbose_name='Дата рождения')
    avatar = models.ImageField(null=True, blank=True, upload_to='user_pics', verbose_name='Аватар')
    phone = models.CharField(max_length=30, null=True, blank=True, verbose_name='Телефон')

    def __str__(self):
        return self.user.get_full_name() + "'s Profile"

    class Meta:
        verbose_name = 'Профиль'
        verbose_name_plural = 'Профили'

source/accounts/forms.py
from django.contrib.auth.models import User
from django import forms
from .models import Profile


class UserCreationForm(forms.ModelForm):
    password = forms.CharField(label="Пароль", strip=False, widget=forms.PasswordInput)
    password_confirm = forms.CharField(label="Подтвердите пароль", widget=forms.PasswordInput, strip=False)

    def clean_password_confirm(self):
        password = self.cleaned_data.get("password")
        password_confirm = self.cleaned_data.get("password_confirm")
        if password and password_confirm and password != password_confirm:
            raise forms.ValidationError('Пароли не совпадают!')
        return password_confirm

    def save(self, commit=True):
        user = super().save(commit=False)
        user.set_password(self.cleaned_data["password"])
        if commit:
            user.save()
        return user

    class Meta:
        model = User
        fields = ['username', 'password', 'password_confirm', 'first_name', 'last_name', 'email']


class UserChangeForm(forms.ModelForm):
    avatar = forms.ImageField(label='Аватар', required=False)
    birth_date = forms.DateField(label='День рождения', input_formats=['%Y-%m-%d', '%d.%m.%Y'], required=False)

    def get_initial_for_field(self, field, field_name):
        if field_name in self.Meta.profile_fields:
            try:
                return getattr(self.instance.profile, field_name)
            except Profile.DoesNotExist:
                return None
        return super().get_initial_for_field(field, field_name)

    def save(self, commit=True):
        user = super().save(commit)
        self.save_profile(commit)
        return user

    def save_profile(self, commit=True):
        try:
            profile = self.instance.profile
        except Profile.DoesNotExist:
            profile = Profile.objects.create(user=self.instance)
        for field in self.Meta.profile_fields:
            setattr(profile, field, self.cleaned_data[field])
        if not profile.avatar:
            profile.avatar = None
        if commit:
            profile.save()

    class Meta:
        model = User
        fields = ['first_name', 'last_name', 'email', 'avatar', 'birth_date']
        profile_fields = ['avatar', 'birth_date']
        labels = {'first_name': 'Имя', 'last_name': 'Фамилия', 'email': 'Email'}


class PasswordChangeForm(forms.ModelForm):
    password = forms.CharField(label="Новый пароль", strip=False, widget=forms.PasswordInput)
    password_confirm = forms.CharField(label="Подтвердите пароль", widget=forms.PasswordInput, strip=False)
    old_password = forms.CharField(label="Старый пароль", strip=False, widget=forms.PasswordInput)

    def clean_password_confirm(self):
        password = self.cleaned_data.get("password")
        password_confirm = self.cleaned_data.get("password_confirm")
        if password and password_confirm and password != password_confirm:
            raise forms.ValidationError('Пароли не совпадают!')
        return password_confirm

    def clean_old_password(self):
        old_password = self.cleaned_data.get('old_password')
        if not self.instance.check_password(old_password):
            raise forms.ValidationError('Старый пароль неправильный!')
        return old_password

    def save(self, commit=True):
        user = self.instance
        user.set_password(self.cleaned_data["password"])
        if commit:
            user.save()
        return user

    class Meta:
        model = User
        fields = ['password', 'password_confirm', 'old_password']

source/accounts/views.py
from django.contrib.auth.mixins import UserPassesTestMixin
from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login, logout
from django.urls import reverse
from django.views.generic import DetailView, UpdateView
from django.contrib.auth.models import User
from .forms import UserCreationForm, UserChangeForm, PasswordChangeForm


def login_view(request, *args, **kwargs):
    context = {}
    if request.method == 'POST':
        username = request.POST.get('username')
        password = request.POST.get('password')
        next_url = request.POST.get('next')
        user = authenticate(request, username=username, password=password)
        if user is not None:
            login(request, user)
            if next_url:
                return redirect(next_url)
            return redirect('webapp:index')
        else:
            context['has_error'] = True
            context['next'] = next_url
            context['username'] = username
    else:
        context = {'next': request.GET.get('next')}
    return render(request, 'registration/login.html', context=context)


def logout_view(request, *args, **kwargs):
    logout(request)
    return redirect('webapp:index')


def register_view(request, *args, **kwargs):
    if request.method == 'POST':
        form = UserCreationForm(data=request.POST)
        if form.is_valid():
            user = form.save()
            login(request, user)
            return redirect('webapp:index')
    else:
        form = UserCreationForm()
    return render(request, 'user_create.html', context={'form': form})


class UserDetailView(DetailView):
    model = User
    template_name = 'user_detail.html'
    context_object_name = 'user_obj'


class UserPersonalInfoChangeView(UserPassesTestMixin, UpdateView):
    model = User
    template_name = 'user_info_change.html'
    form_class = UserChangeForm
    context_object_name = 'user_obj'

    def test_func(self):
        return self.request.user.pk == self.kwargs['pk']

    def get_success_url(self):
        return reverse('accounts:detail', kwargs={'pk': self.object.pk})


class UserPasswordChangeView(UserPassesTestMixin, UpdateView):
    model = User
    template_name = 'user_password_change.html'
    form_class = PasswordChangeForm
    context_object_name = 'user_obj'

    def test_func(self):
        return self.request.user.pk == self.kwargs['pk']

    def get_success_url(self):
        return reverse('accounts:login')

source/accounts/templates/user_create.html
{% extends 'base.html' %}
{% block title %}Регистрация{% endblock %}
{% block content %}
        <h1 class="text-center">Регистрация</h1>
        <form action="{% url 'accounts:create' %}" method="post">
            {% include "partial/form.html" %}
            <button type="submit" class="btn btn-primary">Зарегистрироваться</button>
        </form>
{% endblock %}

source/accounts/templates/user_detail.html
{% extends 'base.html' %}

{% block title %}Пользователь{% endblock %}

{% block menu %}
    {% if user.pk == user_obj.pk %}
        <li class="nav-item"><a class="nav-link" href="{% url "accounts:update" user_obj.pk %}">Редактировать</a></li>
        <li class="nav-item"><a class="nav-link" href="{% url "accounts:password_change" user_obj.pk %}">Смена пароля</a></li>
    {% endif %}
{% endblock %}

{% block content %}
    <h1 class="text-center">Личный кабинет</h1>
    <div class="row">
        <div class="col col-12 col-sm-10 col-md-8 col-lg-6 m-auto">
            {% if user_obj.profile.avatar %}
                <img src="{{ user_obj.profile.avatar.url }}" class="img-fluid" alt="{{ user_obj.username }}">
            {% endif %}
            <div class="mt-3">
                <p><b>Имя пользователя:</b> {{ user_obj.username }}</p>
                <p><b>Имя:</b> {{ user_obj.first_name }}</p>
                <p><b>Фамилия:</b> {{ user_obj.last_name }}</p>
                <p><b>Дата рождения:</b> {{ user_obj.profile.birth_date|date:'d.m.Y' }}</p>
                <p><b>Почта:</b> {{ user_obj.email }}</p>
            </div>
        </div>
    </div>
{% endblock %}

source/accounts/templates/user_info_change.html
{% extends 'base.html' %}

{% block title %}Личный кабинет{% endblock %}

{% block menu %}
    <li class="nav-item"><a class="nav-link" href="{% url "accounts:detail" user_obj.pk %}">Назад</a></li>
    <li class="nav-item"><a class="nav-link" href="{% url "accounts:password_change" user_obj.pk %}">Смена пароля</a></li>
{% endblock %}

{% block content %}
    <h1 class="text-center">Личный кабинет</h1>
    <form action="{% url "accounts:update" user_obj.pk %}" method="post" enctype="multipart/form-data">
        {% include 'partial/form.html' %}
        <input type="submit" value="Сохранить" class="btn btn-primary">
    </form>
{% endblock %}

source/accounts/templates/user_password_change.html
{% extends 'base.html' %}

{% block title %}Смена пароля{% endblock %}

{% block menu %}
    <li class="nav-item"><a class="nav-link" href="{% url "accounts:detail" user_obj.pk %}">Назад</a></li>
    <li class="nav-item"><a class="nav-link" href="{% url "accounts:update" user_obj.pk %}">Редактирование личных данных</a></li>
{% endblock %}

{% block content %}
    <h1 class="text-center">Смена пароля</h1>
    <form action="{% url "accounts:password_change" user_obj.pk %}" method="post">
        {% include 'partial/form.html' %}
        <input type="submit" value="Сохранить" class="btn btn-primary">
    </form>
{% endblock %}